/* Rekurzija : Fibonacijevi brojevi */

/* Fibonacijev niz brojeva se definise kao niz u kome su prva dva broja 
   jednaka 1, a za ostale brojeve vazi da je svaki sledeci zbir dva 
   prethodna. tj. 
	f(0) = 1, f(1) = 1, f(n) = f(n-1) + f(n-2)
*/

#include <stdio.h>
#include <stdlib.h>

/* Rekurzivna implementacija - obratiti paznju na neefikasnost funkcije */
int Fib(int n)
{
	printf("Racunam Fib(%d)\n",n);
	return (n == 0 || n == 1) ? 1 : Fib(n-1) + Fib(n-2);
}

/* Iterativna implementacija sa nizom */
int Fib_array(int n)
{
	int *fib;
 	int i, result;
	
	/* Alociramo niz */
	if ((fib = malloc(n*sizeof(int))) == NULL)
		return -1;
	
	/* Racunamo elemente */
	fib[0] = 1;
	fib[1] = 1; 
	for (i = 2; i<=n; i++)
		fib[i] = fib[i-2] + fib[i-1];

	/* Moramo upamtiti rezultat kako bismo oslobodili niz */
	result = fib[n];

	/* Oslobadjamo niz */
	free(fib);

	return result; 	
}

/* Iterativna verzija bez niza */
int Fib_iterative(int n)
{
	/* Promenljiva pp cuva pretposlednji, a p poslednji element niza */
	int pp = 1, p = 1;
	int i;
	for (i = 0; i <= n-2; i++)
	{	int tmp = pp;
		pp = p;
		p = p + tmp;
	}
	return p;
}


main()
{
	printf("Fib(5) = %d\n", Fib(5));
	printf("Fib(5) = %d\n", Fib_array(5));
	printf("Fib(5) = %d\n", Fib_iterative(5));

}

