/* Sortiranje niza celih brojeva - QuickSort algoritam */


/* Funkcija menja mesto i-tom i j-tom elementu niza a */
void swap(int a[], int i, int j)
{
	int tmp = a[i];
	a[i] = a[j];
	a[j] = tmp;
}

/* Funkcija particionise interval [l, r] niza a, tako da levo od pivota 
   budu svi elementi manji od njega, a desno svi veci od njega. 
   Ovi podnizovi ne moraju biti sortirani. 
   Funkcija vraca poziciju pivota.
*/
int partition(int a[], int l, int r)
{
	int last, i; 

	/* Srednji element uzimamo za pivot i postavljamo ga na pocetak */
	swap(a, l, (l + r)/2);

	/* Niz organizujemo tako da pivot postavimo na pocetak, zatim da iza 
	   njega budu svi elementi manji od njega, pa zatim svi elementi koji 
	   su veci od njega  tj. piv < < < < > > > >*/

	/* last je pozicija poslednjeg elementa niza za koji znamo da je
	   manji od pivota. U pocetku takvih elemenata nema */
	last = l;
	for (i = l+1; i <= r; i++)
		/* Ukoliko je element na poziciji i manji od pivota, 
		   postavljamo ga iza niza elemenata manjih od pivota,
		   menjajuci mu mesto sa prvim sledecim */
		if (a[i] < a[l])
			swap(a, ++last, i);

	/* Zahtevanu konfiguraciju < < < < piv > > > > dobijamo tako 
	   sto zamenimo mesto pivotu i poslednjem elementu manjem od njega */
       	swap(a, l, last);

	/* Pivot se sada nalazi na poziciji last */
	return last;
}

/* Funkcija sortira deo niza brojeva a izmedju pozicija l i r*/
void quick_sort(int a[], int l, int r)
{
	int i, last;
	
	/* Ukoliko je interval [l, r] prazan nema nista da se radi */
	if (l >= r)  
		return;         

	/* Particionisemo interval [l, r] */
	int pivot = partition(a, l, r);

	/* Rekurzivno sortiramo elemente manje od pivota */
	quick_sort(a, l, pivot-1);
	/* Rekurzivno sortiramo elemente vece pivota */
	quick_sort(a, pivot+1, r);
}


main()
{
	int a[] = {5, 8, 2, 4, 1, 9, 3, 7, 6};
	int n = sizeof(a)/sizeof(int);
	int i;

	quick_sort(a, 0, n-1);
			
	for (i = 0; i < n; i++)
		printf("%d ", a[i]);
	printf("\n");
	
}

