/* Sortiranje niza celih brojeva : implementacija genericke funkcije 
   sortiranja - funkcija je nezavisna od tipa elemenata niza koji se 
   sortira */
#include <stdlib.h>

/* Funkcija Selection sort algoritmom sortira niz elemenata proizvoljnog 
   tipa. Argumenti funkcije su :
	adresa pocetka niza data kao void*
	broj elemenata niza
	velicina jednog elementa niza
	pokazivac na funkciju poredjenja dva elementa niza 
*/
void sort(void* a, int n, int size, int (*poredi)(void*, void*))
{
	int i, j;
	for (i = 0; i<n-1; i++)
		for (j = i+1; j<n; j++)
		{
			void* adresa_itog = (char*)a+i*size;
			void* adresa_jtog = (char*)a+j*size;
	
			if (poredi(adresa_itog, adresa_jtog))
			{
				void* tmp = malloc(size);
				memcpy(tmp, adresa_itog, size);
				memcpy(adresa_itog, adresa_jtog, size);
				memcpy(adresa_jtog, tmp, size);
				free(tmp);
			}
			
		}
}


int poredi_br(void* a, void* b)
{
	int br_a = *(int*)a;
	int br_b = *(int*)b;
	
	return br_a>br_b;
}


main()
{
	int a[] = {8, 2, 1, 9, 3, 7, 6, 4, 5};
	int n = sizeof(a)/sizeof(int);
	int i;

	sort(a, n, sizeof(int), &poredi_br);
	
	for (i = 0; i < n; i++)
		printf("%d ", a[i]);
	putchar('\n');
}
