/* Sortiranje (selection sort) i binarna pretraga niza struktura - artikli 
u prodavnici */

#include <stdio.h>

/* Maksimalna duzina imena artikla */
#define MAX_IME 30

/* Struktura za predstavljanje pojedinacnih artikala */
typedef struct _artikal
{
	int bar_kod;
	char ime[MAX_IME];
	float cena;
	float pdv;
} artikal;

/* Maksimalni broj artikala koji se prodaju */
#define MAX_ARTIKALA 1000
artikal artikli[MAX_ARTIKALA];
int br_artikala = 0;

/* Ucitava podatke o jednom artiklu. Vraca da li su podaci uspesno procitani */
int ucitaj_artikal(artikal* a)
{
	scanf("%d", &(a->bar_kod));
	if (a->bar_kod == -1)
		return 0;
	scanf("%s", a->ime);
	scanf("%f", &(a->cena));
	scanf("%f", &(a->pdv));
	
	return 1;
}

/* Selection sort algoritmom se sortiraju artikli na osnovu bar koda */
void sortiraj_artikle()
{
	int i, j;
	for (i = 0; i<br_artikala - 1; i++)
		for (j = i + 1; j<br_artikala; j++)
		{	
			if (artikli[i].bar_kod > artikli[j].bar_kod)
			{
				artikal tmp = artikli[i];
				artikli[i] = artikli[j];
				artikli[j] = tmp;
			}
		}
}

/* Binarnom pretragom se pronalazi pozicija artikla sa datim bar kodom. 
   Funkcija vraca -1 ako takav artikal ne postoji */
int pronadji_artikal(int bar_kod)
{
	int l = 0, d = br_artikala -1;
	while (l<=d)
	{
		int s = (l+d)/2;
		if (artikli[s].bar_kod == bar_kod)
			return s;
		else if (artikli[s].bar_kod < bar_kod)
			l = s + 1;
		else
			d = s - 1;
	}
	return -1;
}

/* Funkcija izracunava ukupnu cenu datog artikla */
float cena(artikal a)
{
	float c = a.cena*(1+a.pdv);
	printf("Dodajem na racun : %-10s - %.2f\n", a.ime, c);
	return c;
}

/* Funkcija ispisuje podatke o svim artiklima */
void ispisi_artikle()
{
	int i;
	for (i = 0; i<br_artikala; i++)
		printf("%8d %10s %.2f %.2f\n", 
			artikli[i].bar_kod, artikli[i].ime, 
			artikli[i].cena, artikli[i].pdv);
}

main()
{
	while (ucitaj_artikal(&artikli[br_artikala++]))
		;
	br_artikala--;	
	sortiraj_artikle(); 
	printf("Artikli uspesno sortirani :\n");
	ispisi_artikle();
	
	float racun = 0.0;
		
	int bar_kod;
	do
	{
		int i;
		do 
		{	scanf("%d", &bar_kod);
		}while (bar_kod != -1 && (i = pronadji_artikal(bar_kod)) == -1);

		if (bar_kod != -1)
			racun += cena(artikli[i]);
		
	} while (bar_kod != -1);

	printf("Vas ukupan racun je : %.2f\n", racun); 
}


