/* Binarno pretrazivacko drvo - drvo sadrzi cele brojeve.
   Ubacivanje realizovano preko eksplicitnog vracanja korena 
    rezultujuceg drveta*/

#include <stdlib.h>
#include <stdio.h>

typedef struct _cvor
{
	int broj;
	struct _cvor *l, *d;
} cvor;

cvor* napravi_cvor(int b)
{
	cvor* novi = (cvor*)malloc(sizeof(cvor));
	if (novi == NULL)
	{
		fprintf(stderr, "Greska prilikom alokacije memorije");
		exit(1);
	}
	novi->broj = b;
	novi->l = NULL;
	novi->d = NULL;
	return novi;
}

cvor* ubaci_u_drvo(cvor* drvo, int b)
{
	if (drvo == NULL)
		return napravi_cvor(b);
	
	if (b < drvo->broj)
		drvo->l = ubaci_u_drvo(drvo->l, b);
	else 
		drvo->d = ubaci_u_drvo(drvo->d, b);

	return drvo;
}

/* Funkcija proverava da li dati broj postoji u drvetu */
int pronadji(cvor* drvo, int b)
{	
	if (drvo == NULL)
		return 0;
	
	if (drvo->broj == b)
		return 1;

	if (b < drvo->broj)
		return pronadji(drvo->l, b);
	else
		return pronadji(drvo->d, b);
}

void ispisi_drvo(cvor* drvo)
{
	if (drvo != NULL)
	{
		ispisi_drvo(drvo->l);
		printf("%d ", drvo->broj);
		ispisi_drvo(drvo->d);
	}
}


void obrisi_drvo(cvor* drvo)
{
	if (drvo != NULL)
	{
		obrisi_drvo(drvo->l);
		obrisi_drvo(drvo->d);
		free(drvo);
	}
}

main()
{
	cvor* drvo = NULL;
	drvo = ubaci_u_drvo(drvo, 1);
	drvo = ubaci_u_drvo(drvo, 8);
	drvo = ubaci_u_drvo(drvo, 5);
	drvo = ubaci_u_drvo(drvo, 3);
	drvo = ubaci_u_drvo(drvo, 7);
	drvo = ubaci_u_drvo(drvo, 6);
	drvo = ubaci_u_drvo(drvo, 9);

	if (pronadji(drvo, 3))
		printf("Pronadjeno 3\n");
	if (pronadji(drvo, 2))
		printf("Pronadjeno 2\n");
	if (pronadji(drvo, 7))
		printf("Pronadjeno 7\n");

	ispisi_drvo(drvo);
	putchar('\n');

	obrisi_drvo(drvo);	
}
