/* Implementacija dinamickih kvadratnih matrica preko pokazivaca na niz pokazivaca na kolone */
#include <stdio.h>
#include <stdlib.h>

/* Tip elemenata matrice ce biti float */
typedef float tip;

/* Funkcija alocira matricu dimenzije n*n */
tip** allocate(int n)
{    tip **m;
     int i;
     /* Alocira se niz pokazivaca na kolone */
     m=(tip**)malloc(n*sizeof(tip*));
     for (i=0; i<n; i++)
        /* Alociraju se nizovi brojeva koji predstavljaju kolone */
        m[i]=(tip*)malloc(n*sizeof(tip));

     return m;
}

/* Funkcija vrsi dealociranje date matrice dimenzije n */
void deallocate(tip** m, int n)
{    int i;
     /* Uklanjaju se kolone */
     for (i=0; i<n; i++)
        free(m[i]);
     /* Uklanja se niz pokazivaca na kolone */
     free(m);
}

/* Funkcija ispisuje datu matricu dimenzije n */
void IspisiMatricu(tip** matrica, int n)
{    int i,j;
     for (i=0; i<n; i++)
     {   for(j=0; j<n; j++)
           printf("%f\t",matrica[i][j]);
         printf("\n");
     }       
}

/* Funkcija ucitava datu matricu i njenu dimenziju */
void UnesiMatricu(tip*** matrica,int *pn)
{    int i,j;
     printf("Unesite dimenziju kvadratne matrice :");
     scanf("%d",pn);

     *matrica=allocate(*pn);
     for (i=0; i<*pn; i++)
        for(j=0; j<*pn; j++)
        {   printf("A[%d][%d]=",i+1,j+1);
            scanf("%f",&((*matrica)[i][j]));
        }
}

/* Rekurzivna funkcija koja vrsi Laplasov razvoj - 
   neefikasna, ali dobra vezba */
tip determinanta(tip** matrica, int n)
{    int i;
     tip** podmatrica;
     int det=0,znak;

     /* Izlaz iz rekurzije je matrica 1x1 */
     if (n==1) 
	return matrica[0][0];
     /* Podmatrica ce da sadrzi minore polazne matrice */		
     podmatrica=allocate(n-1);
     znak=1;
     for (i=0; i<n; i++)
     {  int vrsta,kolona;
        for (kolona=0; kolona<i; kolona++)
           for(vrsta=1; vrsta<n; vrsta++)
             podmatrica[vrsta-1][kolona]=matrica[vrsta][kolona];
        for (kolona=i+1; kolona<n; kolona++)
           for(vrsta=1; vrsta<n; vrsta++)
             podmatrica[vrsta-1][kolona-1]=matrica[vrsta][kolona];

        det+=znak*matrica[0][i]*determinanta(podmatrica,n-1);
        znak*=-1;    
     }
     deallocate(podmatrica,n-1);
     return det;
}

main()
{  
   /* Matrica i njena dimenizija */
   tip **matrica;
   int n;
   
   /* Unosi se matrica */ 
   UnesiMatricu(&matrica,&n);

   /* Ispisuje se determinanta */
   printf("Determinanta je : %f\n",determinanta(matrica,n));
   
   return 0;
}
