/* Program ispisuje sve linije standardnog ulaza u kojima se pojavljuje data rec */
#include <stdio.h>

/* Maksimalna duzina linije */
#define MAX_LINE 100

/* Funkcija ucitava liniju sa standardnog ulaza i smesta je u datu nisku karaktera s.
   lim oznacava maksimalnu duzinu niske i funkcija vodi racuna da se taj limit ne premasi.
   Oznaka za kraj reda se smatra sastavnim delom linije.
   Funkcija vraca broj procitanih karaktera. 
*/
int getline(char s[], int lim)
{
	int c; 
	
	/* Cita se karakter po karakter i smesta u nisku sve dok se ne dodje do 
	   EOF, '\n' ili dok se ne premasi duzina niza (ostavljajuci mesto za '\0')
	   Napomena : zbog lenjog izracunavanja, ukoliko je duzina niza premasena
	   ne cita se sledeci karakter.
	*/
	int i = 0;
	while (i < lim - 1 && (c=getchar()) != EOF && c != '\n')
		s[i++] = c;
	
	/* Posto je '\n' sastavni deo linije i on se smesta u niz */
	if (c == '\n')
		s[i++] = c;
	
	/* Terminira se niska na kraju */
	s[i] = '\0';
	
	return i;
}

int string_string(char str[], char sub[])
{
	int i, j;
	/* Proveravamo da li sub pocinje na svakoj poziciji i */
	for (i = 0; str[i]; i++)
		/* Poredimo sub sa str pocevsi od poziciji i sve dok ne naidjemo na razliku */
		for (j = 0; str[i+j] == sub[j]; j++)
			/* Nismo naisli na razliku a ispitali smo sve karaktere niske sub */
			if (sub[j+1]=='\0') 
				return i;
	/* Nije nadjeno */				
	return -1;
}

main()
{
	/* Ispisujemo sve linije koje sadrze petlju */
	
	/* Niska karaktera koja ce da sadrzi tekucu liniju. 
	   Alociramo prostor od MAX_LINE karaktera */
	char line[MAX_LINE];
	
	/* Citamo liniju - getline vraca 0 kada dodje do kraja ulaza */
	while(getline(line, MAX_LINE)>0)
		/* Ispisujemo one linije koje sadrze rec for ili rec while */
		if (string_string(line, "for") != -1 || string_string(line, "while") != -1)
			printf("%s",line);
}

