/* right_rotate_bits, mirror_bits - rotiranje i simetrija bitova */
#include <stdio.h>

/* Pomocna funkcija - stampa bitove neoznacenog broja */
void print_bits(unsigned x)
{
	int wl = sizeof(unsigned)*8;
	
	unsigned mask;
	for (mask = 1<<wl-1; mask; mask >>= 1)
		putchar(x&mask ? '1' : '0');
	
	putchar('\n');
}


/* Funkcija vrsi rotaciju neoznacenog broja x za n pozicija u desno */
unsigned right_rotate(unsigned x, int n)
{
	int i;
	int wl = sizeof(unsigned)*8;
	
	/* Postupak se ponavlja n puta */
	for (i = 0; i < n; i++)
	{
		/* Poslednji bit broja x */
		unsigned last_bit = x & 1;
		
		/* x pomeramo za jedno mesto u desno */
		x >>= 1;
		
		/* Zapamceni poslednji bit stavljamo na pocetak broja x*/
		
		x |= last_bit<<wl-1;
	}
	
	return x;
}

/* Funkcija obrce binarni zapis neoznacenog broja x tako sto bitove cita unatrag */
unsigned mirror(unsigned x)
{
	int i;
	int wl = sizeof(unsigned)*8;
	
	/* Rezultat inicijalizujemo na poslednji bit broja x */
	unsigned y = x & 1;
	
	/* Postupak se ponavlja wl-1 puta */
	for (i = 1; i<wl; i++)
	{
		/* x se pomera u desno za jedno mesto */
		x >>= 1;
		/* rezultat se pomera u levo za jedno mesto */
		y <<= 1;
		
		/* Poslednji bit broja x upisujemo na poslednje mesto rezultata */
		y |= x & 1;
	}
	return y;
}

main()
{
	unsigned x = 0xFAF0FAF0;
	print_bits(x);
	print_bits(mirror(x));
	print_bits(right_rotate(x, 2));		
}

