/* Demonstrira dinamicku alokaciju memorije koriscenjem funkcije malloc */
/* Program unosi niz proizvoljne dimenzije i nalazi najveci element */

#include <stdio.h>

/* Neophodno je ukljuciti stdlib.h */
#include <stdlib.h>

int main()
{
	int n;

	/* Deklaracija 
		int a[n];
	nije dozvoljena jer kompilator ne moze u vreme prevodjenja 
	da odredi potrebnu kolicinu	memorije. Umesto ovoga, memoriju cemo 
	alocirati dinamicki tj. u fazi izvrsavanja programa kada bude poznata 
	vrednost broja n. Zbog toga je potrebno upamtiti samo adresu pocetka 
	alociranog bloka memorije sto cemo uraditi koriscenjem sledeceg pokazivaca:
	*/
	int* a;

	int i, max;

	printf("Unesi dimenziju niza : ");
	scanf("%d", &n);

	/* U ovom treunutku znamo koliko nam je memorije potrebno i pozivamo 
	   funkciju malloc za dinamicku alokaciju. malloc-u se prosledjuje kolicina
	   potrebne memorije u bajtovima, a on vraca genericki pokazivac (void*) koji
	   pre koriscenja treba konvertovati u odgovarajuci realni pokazivacki tip.
	*/
	
	a = (int*) malloc(n*sizeof(int));

	/* U slucaju da nema dovoljno memorije malloc vraca NULL */
	if (a == NULL)
	{
		printf("Greska : Nema dovoljno memorije!\n");
		return 1;
	}

	/* Nadalje a koristimo kao obican niz */
	for (i = 0; i<n; i++)
	{
		printf("a[%d]=", i);
		scanf("%d", &a[i]);
	}

	/* Nalazimo maksimum */
	max = a[0]; 
	for (i = 1; i<n; i++)
		if (a[i] > max)
			max = a[i];

	printf("Najveci element je %d\n", max);

	/* Duzni smo da rucno alociranu memoriju rucno i oslobodimo */
	free(a);

	return 0;

}

