/* Vracanje niza iz funkcije */
/* Program unosi niz proizvoljne dimenzije i nalazi najveci element */

#include <stdio.h>

/* Neophodno je ukljuciti stdlib.h */
#include <stdlib.h>

/* Moguce je vratiti pokazivac na dinamicki alocirani niz jer se on 
   alocira na hip-u i taj prostor je rezervisan i posle zavrsetka rada funkcije */
int* CreateIntArray(int n)
{
	return (int*) malloc(n*sizeof(int));
}

/* Nije moguce vratiti pokazivac na lokalni niz jer se on alocira na steku 
   i taj prostor nije rezervisan posle zavrsetka rada funkcije */
int* Create10ElementIntArray()
{
	int a[10];
	return a;
}


int main()
{
	int n;

	int* a;
	int i, max;

	printf("Unesi dimenziju niza : ");
	scanf("%d", &n);

	/* Alociramo memoriju */
	a = CreateIntArray(n);

	/* U slucaju da nema dovoljno memorije malloc vraca NULL */
	if (a == NULL)
	{
		printf("Greska : Nema dovoljno memorije!\n");
		return 1;
	}

	/* Nadalje a koristimo kao obican niz */
	for (i = 0; i<n; i++)
	{
		printf("a[%d]=", i);
		scanf("%d", &a[i]);
	}

	/* Nalazimo maksimum */
	max = a[0]; 
	for (i = 1; i<n; i++)
		if (a[i] > max)
			max = a[i];

	printf("Najveci element je %d\n", max);

	/* Duzni smo da rucno alociranu memoriju rucno i oslobodimo */
	free(a);

	return 0;

}

