/* Program demonstrira otvaranje datoteka ("r" - read i "w" - write mod) i osnovne
   tehnike rada sa datotekama */

/* U datoteku se upisuje prvih 10 prirodnih brojeva, a zatim se iz iste datoteke 
   citaju brojevi dok se ne stigne do kraja i ispisuju se na standardni izlaz */

#include <stdio.h>

/* Zbog funkcije exit */
#include <stdlib.h> 

main()
{
	int i;

	/* Otvaramo datoteku sa imenom podaci.txt za pisanje */
	FILE* f = fopen("podaci.txt", "w");

	/* Ukoliko otvaranje nije uspelo, fopen vraca NULL. U tom slucaju,
	   prijavljujemo gresku i zavrsavamo program */ 
	if (f == NULL)
	{
		printf("Greska prilikom otvaranja datoteke podaci.txt za pisanje\n");
		exit(1);
	}

	/* Upisujemo u datoteku prvih 10 prirodnih brojeva (svaki u posebnom redu) */
	for (i = 0; i<10; i++)
		fprintf(f, "%d\n", i);

	/* Zatvaramo datoteku */
	fclose(f);

	/* Otvaramo datoteku sa imenom podaci.txt za citanje */
	f = fopen("podaci.txt", "r");

	/* Ukoliko otvaranje nije uspelo, fopen vraca NULL. U tom slucaju,
	   prijavljujemo gresku i zavrsavamo program */ 
	if (f == NULL)
	{
		printf("Greska prilikom otvaranja datoteke podaci.txt za citanje\n");
		exit(1);
	}

	/* Citamo brojeve iz datoteke dok ne stignemo do kraja i ispisujemo ih 
	   na standardni izlaz */
	while(1)
	{
		int br;
		/* Pokusavamo da procitamo broj */
		fscanf(f, "%d", &br);

		/* Ukoliko smo dosli do kraja datoteke, prekidamo */
		if (feof(f))
			break;

		/* Ispisujemo procitani broj */
		printf("Procitano : %d\n", br); 
	}

	/* Funkciju feof ne bi trebalo pozivati pre pokusaja citanja.
	   Sledeci kod moze dovesti do greske:
	
		while (!feof(f))
			scanf("%d",&br);
	
	*/


	/* Zatvaramo datoteku */
	fclose(f);

	
	
}
