/* Program ilustruje rad sa datotekama. Program kopira datoteku cije 
   se ime zadaje kao prvi argument komandne linije u datoteku cije se ime
   zadaje kao drugi argument komandne linije. */
/* Uz svaku liniju se zapisuje i njen broj */
#include <stdio.h>

#define MAX_LINE 256

/* Funkcija getline iz K&R jednostavno realizovana preko funkcije fgets */

int getline(char s[], int lim)
{   
	char* c = fgets(s, lim, stdin);
	return c==NULL ? 0 : strlen(s);
}

main(int argc, char* argv[])
{    
	char line[MAX_LINE];
	FILE *in, *out;
	int line_num;

	if (argc != 3)
	{    
		fprintf(stderr,"Upotreba : %s ulazna_datoteka izlazna_datoteka\n",
			argv[0]);
		return 1;
	}

	if ((in = fopen(argv[1],"r")) == NULL)
	{    
		fprintf(stderr, "Neuspesno otvaranje datoteke %s\n", argv[1]);
		return 1;
	}

	if ((out = fopen(argv[2],"w")) == NULL)
	{    
		fprintf(stderr, "Neuspesno otvaranje datoteke %s\n",argv[2]);
		return 1;
	}

	/*  Prepisivanje karakter po karakter je moguce ostvariti preko:
		int c;
		while ((c=fgetc(ulaz)) != EOF)
			putc(c,izlaz);
	*/
    
	line_num = 1;
	/* Citamo liniju po liniju sa ulaza*/
	while (fgets(line, MAX_LINE, in) != NULL)
	{    
		/* Ispisujemo broj linije i sadrzaj linije na izlaz */
		fprintf(out, "%-3d :\t", line_num++);
		fputs(line, out);
	}

	/* Zatvaramo datoteke */
	fclose(in); 
	fclose(out);
}
